background = nil
cursor = nil
frame = 1
romance =
{
	game =
	{
		name = "Untitled Game",
		viewport =
		{
			height = 2000,
			width = 3200
		}
	},
	-- fix this, change to size only
	texture =
	{
		height = 512,
		width = 512
	}
}

function romance.setCursor(name)
	cursor1 = love.graphics.newImage("game/cursor/" .. name .. "/frame-00.png")
	cursor2 = love.graphics.newImage("game/cursor/" .. name .. "/frame-01.png")
end

function romance.newTiledImage(name)
	local texture
	local height
	local image
	local tiled
	local width

	image = love.image.newImageData(name)
	height = image:getHeight()
	width = image:getWidth()
	tiled = {}
	tiled.width = math.floor(width / romance.texture.width) + 1
	for y = 0, height, romance.texture.height do
		for x = 0, width, romance.texture.width do
			texture = love.image.newImageData(romance.texture.width, romance.texture.height)
			texture:paste(image, 0, 0, x, y, romance.texture.width, romance.texture.height)
			table.insert(tiled, love.graphics.newImage(texture))
		end
	end
	print(#tiled)

	return tiled
end

function romance.drawTiledImage(image, x, y)
	local width

	width = image.width
	for i = 1, #image, 1 do
		love.graphics.draw(image[i], ((i - 1) % width) * romance.texture.width + x, math.floor((i - 1) / width) * romance.texture.height + y)
	end
end

function love.load()
	-- This is only required for <= 0.8.0 -- bug is fixed in more recent builds
	if not love.graphics.setMode(love.graphics.getWidth(), love.graphics.getHeight(), true, false, 0) then
		love.event.quit()
	end
	love.filesystem.load("game/game.lua")()
	if romance.game.viewport.width / romance.game.viewport.height > love.graphics.getWidth() / love.graphics.getHeight() then
		romance.game.viewport.scale = love.graphics.getWidth() / romance.game.viewport.width;
		romance.game.viewport.y = (love.graphics.getHeight() - (romance.game.viewport.scale * romance.game.viewport.height)) / 2 / romance.game.viewport.scale
		romance.game.viewport.x = 0
	else
		romance.game.viewport.scale = love.graphics.getHeight() / romance.game.viewport.height;
		romance.game.viewport.x = (love.graphics.getWidth() - (romance.game.viewport.scale * romance.game.viewport.width)) / 2 / romance.game.viewport.scale
		romance.game.viewport.y = 0
	end
	love.filesystem.setIdentity("Some game")
	quad = romance.newTiledImage("game/location/0000000b.png")
	romance.setCursor("default")
	love.graphics.setFont(love.graphics.newFont(32))
end

function love.draw()
	local mouseX;
	local mouseY;
	love.graphics.scale(romance.game.viewport.scale, romance.game.viewport.scale)
	love.graphics.translate(romance.game.viewport.x, romance.game.viewport.y)
	-- love.graphics.draw(background, 0, 0)
	romance.drawTiledImage(quad, 0, 0);
	love.graphics.print(love.mouse.getX(), 400, 230)
	love.graphics.print(love.mouse.getY(), 500, 230)
	mouseX = love.mouse.getX() / romance.game.viewport.scale;
	mouseY = love.mouse.getY() / romance.game.viewport.scale;
	if mouseX > romance.game.viewport.width - (1 / romance.game.viewport.scale) then
		mouseX = romance.game.viewport.width - (1 / romance.game.viewport.scale)
		love.mouse.setPosition(mouseX * romance.game.viewport.scale, mouseY * romance.game.viewport.scale)
	end
	if mouseY > romance.game.viewport.height - (1 / romance.game.viewport.scale) then
		mouseY = romance.game.viewport.height - (1 / romance.game.viewport.scale)
		love.mouse.setPosition(mouseX * romance.game.viewport.scale, mouseY * romance.game.viewport.scale)
	end
	if frame == 1 then
		frame = 2
		love.graphics.draw(cursor1, mouseX, mouseY)
	else
		frame = 1
		love.graphics.draw(cursor2, mouseX, mouseY)
	end
	love.graphics.print(mouseX, 400, 300)
	love.graphics.print(mouseY, 400, 330)
end

function love.keypressed(key)
    if key == "escape" then
	love.event.quit()
    end
end
